#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_cJIK2x0x80TN2x1x1_a1_b1
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=2, NB=0, KB=80, 
 * lda=80, ldb=80, ldc=0, mu=2, nu=1, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Nb N
   const float *stM = A + 160;
   const float *stN = B + (((Nb) << 6)+((Nb) << 4));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*2*1)/(2*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 80, incAn = -160;
   #define incBk 1
   const int incBm = -80, incBn = 80;
   #define incCm 4
   const int incCn = (((ldc) << 1)) - 4;
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1;
   register float rB0;
   register float rC0_0, rC1_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA);
      pfA += incPFA;
      rC0_0 = *pC0;
      rC1_0 = pC0[2];
      for (k=80; k; k--) /* easy loop to unroll */
      {
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[80];
         rC0_0 += rA0 * rB0;
         rC1_0 += rA1 * rB0;
         pA0 += incAk;
         pB0 += incBk;
      }
      *pC0 = rC0_0;
      pC0[2] = rC1_0;
      pC0 += incCm;
      pA0 += incAm;
      pB0 += incBm;
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
static void ATL_cJIK80x0x80TN6x1x1_a1_b1
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=80, NB=0, KB=80, 
 * lda=80, ldb=80, ldc=0, mu=6, nu=1, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Nb N
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + 6240;
   const float *stN = B + (((Nb) << 6)+((Nb) << 4));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*6*1)/(80*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 400, incAn = -6240;
   #define incBk 1
   const int incBm = -80, incBn = 80;
   #define incCm 12
   const int incCn = (((ldc) << 1)) - 156;
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3, rA4, rA5;
   register float rB0;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rC0_0 = *pC0;
         rC1_0 = pC0[2];
         rC2_0 = pC0[4];
         rC3_0 = pC0[6];
         rC4_0 = pC0[8];
         rC5_0 = pC0[10];
         for (k=80; k; k--) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[80];
            rA2 = pA0[160];
            rA3 = pA0[240];
            rA4 = pA0[320];
            rA5 = pA0[400];
            rC0_0 += rA0 * rB0;
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         pC0[4] = rC2_0;
         pC0[6] = rC3_0;
         pC0[8] = rC4_0;
         pC0[10] = rC5_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
   ATL_cJIK2x0x80TN2x1x1_a1_b1(2, N, 80, alpha, ca + 6240, lda, cb, ldb, beta, cc + 156, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_cJIK2x0x80TN2x6x1_a1_b1
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=2, NB=0, KB=80, 
 * lda=80, ldb=80, ldc=0, mu=2, nu=6, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Nb = (N/6)*6;
   const float *stM = A + 160;
   const float *stN = B + (((Nb) << 6)+((Nb) << 4));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*2*6)/(2*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 80, incAn = -160;
   #define incBk 1
   const int incBm = -80, incBn = 480;
   #define incCm 4
   const int incCn = (((ldc) << 3)+((ldc) << 2)) - 4;
   float *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1)), *pC4=pC3+(((ldc) << 1)), *pC5=pC4+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1;
   register float rB0, rB1, rB2, rB3, rB4, rB5;
   register float rC0_0, rC1_0, rC0_1, rC1_1, rC0_2, rC1_2, rC0_3, rC1_3, rC0_4, rC1_4, rC0_5, rC1_5;
   do /* N-loop */
   {
      ATL_pfl1R(pfA);
      pfA += incPFA;
      rC0_0 = *pC0;
      rC1_0 = pC0[2];
      rC0_1 = *pC1;
      rC1_1 = pC1[2];
      rC0_2 = *pC2;
      rC1_2 = pC2[2];
      rC0_3 = *pC3;
      rC1_3 = pC3[2];
      rC0_4 = *pC4;
      rC1_4 = pC4[2];
      rC0_5 = *pC5;
      rC1_5 = pC5[2];
      for (k=80; k; k--) /* easy loop to unroll */
      {
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[80];
         rB1 = pB0[80];
         rB2 = pB0[160];
         rB3 = pB0[240];
         rB4 = pB0[320];
         rC0_0 += rA0 * rB0;
         rB5 = pB0[400];
         rC1_0 += rA1 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC0_5 += rA0 * rB5;
         rC1_5 += rA1 * rB5;
         pA0 += incAk;
         pB0 += incBk;
      }
      *pC0 = rC0_0;
      pC0[2] = rC1_0;
      *pC1 = rC0_1;
      pC1[2] = rC1_1;
      *pC2 = rC0_2;
      pC2[2] = rC1_2;
      *pC3 = rC0_3;
      pC3[2] = rC1_3;
      *pC4 = rC0_4;
      pC4[2] = rC1_4;
      *pC5 = rC0_5;
      pC5[2] = rC1_5;
      pC0 += incCm;
      pC1 += incCm;
      pC2 += incCm;
      pC3 += incCm;
      pC4 += incCm;
      pC5 += incCm;
      pA0 += incAm;
      pB0 += incBm;
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pC5 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_cJIK80x0x80TN80x80x0_a1_b1
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=80, NB=0, KB=80, 
 * lda=80, ldb=80, ldc=0, mu=6, nu=6, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Nb = (N/6)*6;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + 6240;
   const float *stN = B + (((Nb) << 6)+((Nb) << 4));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*6*6)/(80*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 400, incAn = -6240;
   #define incBk 1
   const int incBm = -80, incBn = 480;
   #define incCm 12
   const int incCn = (((ldc) << 3)+((ldc) << 2)) - 156;
   float *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1)), *pC4=pC3+(((ldc) << 1)), *pC5=pC4+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3, rA4, rA5;
   register float rB0, rB1, rB2, rB3, rB4, rB5;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC5_1, rC0_2, rC1_2, rC2_2, rC3_2, rC4_2, rC5_2, rC0_3, rC1_3, rC2_3, rC3_3, rC4_3, rC5_3, rC0_4, rC1_4, rC2_4, rC3_4, rC4_4, rC5_4, rC0_5, rC1_5, rC2_5, rC3_5, rC4_5, rC5_5;
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rC0_0 = *pC0;
            rC1_0 = pC0[2];
            rC2_0 = pC0[4];
            rC3_0 = pC0[6];
            rC4_0 = pC0[8];
            rC5_0 = pC0[10];
            rC0_1 = *pC1;
            rC1_1 = pC1[2];
            rC2_1 = pC1[4];
            rC3_1 = pC1[6];
            rC4_1 = pC1[8];
            rC5_1 = pC1[10];
            rC0_2 = *pC2;
            rC1_2 = pC2[2];
            rC2_2 = pC2[4];
            rC3_2 = pC2[6];
            rC4_2 = pC2[8];
            rC5_2 = pC2[10];
            rC0_3 = *pC3;
            rC1_3 = pC3[2];
            rC2_3 = pC3[4];
            rC3_3 = pC3[6];
            rC4_3 = pC3[8];
            rC5_3 = pC3[10];
            rC0_4 = *pC4;
            rC1_4 = pC4[2];
            rC2_4 = pC4[4];
            rC3_4 = pC4[6];
            rC4_4 = pC4[8];
            rC5_4 = pC4[10];
            rC0_5 = *pC5;
            rC1_5 = pC5[2];
            rC2_5 = pC5[4];
            rC3_5 = pC5[6];
            rC4_5 = pC5[8];
            rC5_5 = pC5[10];
            for (k=80; k; k--) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[80];
               rA2 = pA0[160];
               rA3 = pA0[240];
               rA4 = pA0[320];
               rA5 = pA0[400];
               rC0_0 += rA0 * rB0;
               rB1 = pB0[80];
               rB2 = pB0[160];
               rB3 = pB0[240];
               rB4 = pB0[320];
               rB5 = pB0[400];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC0_1 += rA0 * rB1;
               rC1_1 += rA1 * rB1;
               rC2_1 += rA2 * rB1;
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC5_1 += rA5 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rC5_2 += rA5 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC2_3 += rA2 * rB3;
               rC3_3 += rA3 * rB3;
               rC4_3 += rA4 * rB3;
               rC5_3 += rA5 * rB3;
               rC0_4 += rA0 * rB4;
               rC1_4 += rA1 * rB4;
               rC2_4 += rA2 * rB4;
               rC3_4 += rA3 * rB4;
               rC4_4 += rA4 * rB4;
               rC5_4 += rA5 * rB4;
               rC0_5 += rA0 * rB5;
               rC1_5 += rA1 * rB5;
               rC2_5 += rA2 * rB5;
               rC3_5 += rA3 * rB5;
               rC4_5 += rA4 * rB5;
               rC5_5 += rA5 * rB5;
               pA0 += incAk;
               pB0 += incBk;
            }
            *pC0 = rC0_0;
            pC0[2] = rC1_0;
            pC0[4] = rC2_0;
            pC0[6] = rC3_0;
            pC0[8] = rC4_0;
            pC0[10] = rC5_0;
            *pC1 = rC0_1;
            pC1[2] = rC1_1;
            pC1[4] = rC2_1;
            pC1[6] = rC3_1;
            pC1[8] = rC4_1;
            pC1[10] = rC5_1;
            *pC2 = rC0_2;
            pC2[2] = rC1_2;
            pC2[4] = rC2_2;
            pC2[6] = rC3_2;
            pC2[8] = rC4_2;
            pC2[10] = rC5_2;
            *pC3 = rC0_3;
            pC3[2] = rC1_3;
            pC3[4] = rC2_3;
            pC3[6] = rC3_3;
            pC3[8] = rC4_3;
            pC3[10] = rC5_3;
            *pC4 = rC0_4;
            pC4[2] = rC1_4;
            pC4[4] = rC2_4;
            pC4[6] = rC3_4;
            pC4[8] = rC4_4;
            pC4[10] = rC5_4;
            *pC5 = rC0_5;
            pC5[2] = rC1_5;
            pC5[4] = rC2_5;
            pC5[6] = rC3_5;
            pC5[8] = rC4_5;
            pC5[10] = rC5_5;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pC3 += incCm;
            pC4 += incCm;
            pC5 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pC3 += incCn;
         pC4 += incCn;
         pC5 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_cJIK80x0x80TN6x1x1_a1_b1(80, k, 80, alpha, ca, lda, cb + (((Nb) << 6)+((Nb) << 4)), ldb, beta, cc + (((Nb*ldc) << 1)), ldc);
   if (Nb)

      ATL_cJIK2x0x80TN2x6x1_a1_b1(2, Nb, 80, alpha, ca + 6240, lda, cb, ldb, beta, cc + 156, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifdef ATL_UCLEANN
#define ATL_cpNBmm_b1 ATL_cgpNBmm_b1
#endif

void ATL_cJIK80x0x80TN80x80x0_a1_bX(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc);
void ATL_cJIK80x0x80TN80x80x0_a1_bX(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc);
void ATL_cJIK80x0x80TN80x80x0_a1_b1(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc);

void ATL_cpNBmm_b1(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc)
{
   ATL_cJIK80x0x80TN80x80x0_a1_bX(M, N, K, alpha, A, lda, B, ldb, -beta, C, ldc);
   ATL_cJIK80x0x80TN80x80x0_a1_bX(M, N, K, alpha, A, lda, B+N*ldb, ldb, beta, C+1, ldc);
   ATL_cJIK80x0x80TN80x80x0_a1_bX(M, N, K, alpha, A+M*lda, lda, B+N*ldb, ldb, -1.0, C, ldc);
   ATL_cJIK80x0x80TN80x80x0_a1_b1(M, N, K, alpha, A+M*lda, lda, B, ldb, 1.0, C+1, ldc);
}
